<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.7.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <title>List Users</title>
</head>
<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */

     /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function(){
        onPageLoad();
    });
     /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoad(){
        loadUserDataByApiToTable();
    }

    // ham sua user
    function onBtnUserEditClick(paramEditButton){
        console.log("edit");
        console.log($(paramEditButton).data("id"));
    }

    // hàm xóa user
    function onBtnUserDeleteClick(paramDeleteButton){
        console.log("delete");
        console.log($(paramDeleteButton).data("id"));
    }

     /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
     function loadUserDataByApiToTable(){
        $.ajax({
            url : "http://203.171.20.210:8080/crud-api/users/",
            type : "GET",
            success : function(res){
                putDataToTable(res);
            },
            error : function(paramError){
                console.log(paramError);
            }
        });
     }

     function putDataToTable(paramUsers){
        var vUserTable = $("#table-users");
        for (var bIndex=0; bIndex < paramUsers.length ; bIndex++){
            var vNewRow = $("<tr>").appendTo(vUserTable);
            
            $("<td>",{
                html : paramUsers[bIndex].id
            }).appendTo(vNewRow);
            $("<td>",{
                html : paramUsers[bIndex].firstname
            }).appendTo(vNewRow);
            $("<td>",{
                html : paramUsers[bIndex].lastname
            }).appendTo(vNewRow);
            $("<td>",{
                html : paramUsers[bIndex].country
            }).appendTo(vNewRow);
            $("<td>",{
                html : paramUsers[bIndex].subject
            }).appendTo(vNewRow);
            $("<td>",{
                html : paramUsers[bIndex].customerType
            }).appendTo(vNewRow);
            $("<td>",{
                html : paramUsers[bIndex].registerStatus
            }).appendTo(vNewRow);

            // chen nut vao cot action
            var bActionCell = $("<td>").appendTo(vNewRow);
            $("<button>",{
                html : "Sửa",
                class : "btn btn-primary button-edit-user"
            }).data("id",paramUsers[bIndex].id)
            .appendTo(bActionCell);

            $("<button>",{
                html : "Xóa",
                class : "btn btn-danger button-delete-user"
            }).data("id",paramUsers[bIndex].id)
            .appendTo(bActionCell);
        }

        // chen sư kien cho nut
        $(".button-edit-user").click(function(){
            onBtnUserEditClick(this);
        })
        $(".button-delete-user").click(function(){
            onBtnUserDeleteClick(this);
        })
     }
</script>
<body>
    <div class="container">
        <h2 class="text-center my-4">Danh sách người dùng đăng ký</h2>
        <table id="table-users" class="table table-striped table-bordered table-hover">
            <thead>
                <tr>
                    <th scope="col">ID</th>
                    <th scope="col">Firstname</th>
                    <th scope="col">Lastname</th>
                    <th scope="col">Country</th>
                    <th scope="col">Subject</th>
                    <th scope="col">Customer Type</th>
                    <th scope="col">Register Status</th>
                    <th scope="col">Action</th>
                </tr>
            </thead>
            <tbody>

            </tbody>
        </table>
    </div>
</body>

</html>
